---
name: Bug report
about: Create a bug report to help us improve AdGuard Home

---

<!--  As an open-source project with a dedicated but small maintainer team, it can sometimes take a long time for issues to be addressed so please be patient and we will get back to you as soon as we can.
-->

### Prerequisites

Please answer the following questions for yourself before submitting an issue. **YOU MAY DELETE THE PREREQUISITES SECTION.**

- [ ] I am running the latest version
- [ ] I checked the documentation and found no answer
- [ ] I checked to make sure that this issue has not already been filed

### Issue Details

<!--- Please include all relevant details about the environment you experienced the bug in -->

* **Version of AdGuard Home server:**
  * <!-- (e.g. v1.0) -->
* **How did you setup DNS configuration:**
  * <!-- (System/Router/IoT) -->
* **If it's a router or IoT, please write device model:**
  * <!-- (e.g. Raspberry Pi 3 Model B) -->
* **Operating system and version:**
  * <!-- (e.g. Ubuntu 18.04.1) -->

### Expected Behavior
<!-- A clear and concise description of what you expected to happen. -->

### Actual Behavior
<!-- A clear and concise description of what actually happened. -->

### Screenshots
<!-- If applicable, add screenshots to help explain your problem. -->

<details><summary>Screenshot:</summary>

<!--- drag and drop, upload or paste your screenshot to this area-->

</details>

### Additional Information
<!-- Add any other context about the problem here. -->
